<p align="center">
    $${\Huge{\textbf{\textsf{\color{#2E8B57}Bio\color{red}fit}}}}$$
    <br/>
    <br/>
</p>
<p align="center">
    <a href="https://github.com/psmyth94/biofit/actions/workflows/ci_cd_pipeline.yml?query=branch%3Amain"><img alt="Build" src="https://github.com/psmyth94/biofit/actions/workflows/ci_cd_pipeline.yml/badge.svg?branch=main"></a>
    <a href="https://github.com/psmyth94/biofit/blob/main/LICENSE"><img alt="GitHub" src="https://img.shields.io/github/license/psmyth94/biofit.svg?color=blue"></a>
    <a href="https://github.com/psmyth94/biofit/tree/main/docs"><img alt="Documentation" src="https://img.shields.io/website/http/github/psmyth94/biofit/tree/main/docs.svg?down_color=red&down_message=offline&up_message=online"></a>
    <a href="https://github.com/psmyth94/biofit/releases"><img alt="GitHub release" src="https://img.shields.io/github/release/psmyth94/biofit.svg"></a>
    <a href="CODE_OF_CONDUCT.md"><img alt="Contributor Covenant" src="https://img.shields.io/badge/Contributor%20Covenant-2.0-4baaaa.svg"></a>
    <!-- <a href="https://zenodo.org/records/14028772"><img src="https://zenodo.org/badge/DOI/10.5281/zenodo.14028772.svg" alt="DOI"></a> -->
</p>

**Biofit** is a machine learning library designed for bioinformatics datasets. It
provides tools for transforming, extracting, training, and evaluating machine learning
models on biomedical data. It also provides automatic data preprocessing, visualization,
and configurable processing pipelines. Here are some of the main features of Biofit:

- **Automatic Data Preprocessing:** Automatically preprocess biomedical datasets using
  built-in preprocessing steps.
- **Automatic Visualization:** Automatically visualize data using built-in visualization
  methods geared towards biomedical data.
- **Configurable Processing Pipelines:** Define and customize data processing pipelines.
- **Data Handling Flexibility:** Support for a wide range of data formats, including:
  - [Pandas](https://github.com/pandas-dev/pandas)
  - [Polars](https://github.com/pola-rs/polars)
  - [NumPy](https://github.com/numpy/numpy)
  - [CSR (SciPy)](https://github.com/scipy/scipy)
  - [Arrow](https://github.com/apache/arrow)
  - 🤗 [Datasets](https://github.com/huggingface/datasets)
  - [Biosets](https://github.com/psmyth94/biosets)
- **Machine Learning Models:** Supports a wide range of machine learning models, including:
  - [Scikit-learn](https://github.com/scikit-learn/scikit-learn)
    - [Random Forest](https://scikit-learn.org/stable/modules/generated/sklearn.ensemble.RandomForestClassifier.html)
    - [Support Vector Machine](https://scikit-learn.org/stable/modules/generated/sklearn.svm.SVC.html)
    - [Logistic Regression](https://scikit-learn.org/stable/modules/generated/sklearn.linear_model.LogisticRegression.html)
    - [Lasso Regression](https://scikit-learn.org/stable/modules/generated/sklearn.linear_model.Lasso.html)
  - [LightGBM](https://github.com/microsoft/LightGBM)
  - More to come!
- **Caching and Reuse:** Caches intermediate results using Apache Arrow for efficient reuse.
- **Batch Processing and Multiprocessing:** Utilize batch processing and multiprocessing for efficient handling of large-scale data.

## Installation

You can install Biofit via pip:

```bash
pip install biofit
```

## Quick Start

### Preprocessing Data

Biofit provides preprocessing capabilities tailored for omics data. You can use
built-in classes to load preprocessing steps based on the experiment type or create
custom preprocessing pipelines. The preprocessing pipeline in Biofit uses a syntax
similar to sklearn and supports distributed processing.

#### Using a Preprocessor

Biofit allows you to fit and transform your data in a few lines, similar to sklearn.
For example, you can use the LogTransformer to apply a log transformation to your data:

```python
from biofit.preprocessing import LogTransformer
import pandas as pd

dataset = pd.DataFrame({"feature1": [1, 2, 3, 4, 5]})
log_transformer = LogTransformer()
preprocessed_data = log_transformer.fit_transform(dataset)
# Applying log transformation: 100%|█████████████████████████████| 5/5 [00:00<00:00, 7656.63 examples/s]
print(preprocessed_data)
#    feature1
# 0  0.000000
# 1  0.693147
# 2  1.098612
# 3  1.386294
# 4  1.609438
```

#### Auto Preprocessing

You can automatically apply standard preprocessing steps by specifying the experiment
type. This allows you to load tailored preprocessing steps for the type of data you are
working with, such as "otu", "asv", "snp", or "maldi":

```python
from biofit.preprocessing import AutoPreprocessor

preprocessor = AutoPreprocessor.for_experiment("snp", [{"min_prevalence": 0.1}, None])
print(preprocessor)
# [('min_prevalence_row', MinPrevalencFilter(min_prevalence=0.1)),
#  ('min_prevalence', MinPrevalenceFeatureSelector(min_prevalence=0.01))]

# Fit and transform the dataset using the preprocessor
preprocessed_data = preprocessor.fit_transform(dataset)
```

Biofit is made with [Biosets](https://github.com/psmyth94/biosets) in mind. You can
pass the loaded dataset instead of a string to load the preprocessors:

```python
from biosets import load_dataset

dataset = load_dataset("csv", data_files="my_file.csv", experiment_type="snp")

preprocessor = AutoPreprocessor.for_experiment(dataset)
print(preprocessor)
# [('min_prevalence_row', MinPrevalencFilter(min_prevalence=0.01)),
#  ('min_prevalence', MinPrevalenceFeatureSelector(min_prevalence=0.01))]
preprocessed_data = preprocessor.fit_transform(dataset)
```

#### Custom Preprocessing Pipeline

Biofit allows you to create custom preprocessing pipelines using the
`PreprocessorPipeline` class. This allows chaining multiple preprocessing steps from
`sklearn` and Biofit in a single operation:

```python
from biofit import load_dataset
from biofit.preprocessing import LogTransformer, PreprocessorPipeline
from sklearn.preprocessing import StandardScaler

# Load the dataset
dataset = load_dataset("csv", data_files="my_file.csv")

# Define a custom preprocessing pipeline
pipeline = PreprocessorPipeline(
    [("scaler", StandardScaler()), ("log_transformer", LogTransformer())]
)

# Fit and transform the dataset using the pipeline
preprocessed_data = pipeline.fit_transform(dataset.to_pandas())
```

For further details, check the [advance usage documentation](./docs/PREPROCESSING.md).

# License

Biofit is licensed under the Apache 2.0 License. See the [LICENSE](./LICENSE) file for
more information.

# Contributing

If you would like to contribute to Biofit, please read the
[CONTRIBUTING](./CONTRIBUTING.md) guidelines.

source(file.path(R_SCRIPTS_PATH, "plotting_utils.R"))
source(file.path(R_SCRIPTS_PATH, "utils.R"))

plot_sample_metadata <- function(
    data, outcome = NULL,
    sample_metadata_columns = NULL,
    outcome_column = NULL,
    path,
    device = "pdf") {

  suppressPackageStartupMessages(require(ggplot2))
  suppressPackageStartupMessages(require(RColorBrewer))
  suppressPackageStartupMessages(require(circlize))
  suppressPackageStartupMessages(require(patchwork))
  width <- 7
  height <- 7
  if (device[1] != ".") {
    device <- paste0(".", device)
  }
  data <- convert_to_dataframe(data)
  sample_metadata_columns <- get_default_columns(
    data, sample_metadata_columns,
    max_cols = NULL
  )
  data <- validate_data(data, sample_metadata_columns)

  if (!is.null(outcome)) {
    outcome <- convert_to_dataframe(outcome)
    outcome_column <- get_default_columns(outcome, outcome_column, max_cols = 1)
    outcome <- validate_data(outcome, outcome_column)
    data <- concatenate_datasets(
      data[, sample_metadata_columns], outcome,
      how = "horizontal"
    )
  } else if (!is.null(outcome_column)) {
    outcome_column <- get_default_columns(data, outcome_column, max_cols = 1)
  } else {
    stop("Please provide either an outcome or an outcome column")
  }

  # get filename from path
  file_name <- gsub("\\.[^.]*$", "", basename(path))
  path <- dirname(path)
  # Get Outcome Type
  outcome_type <- detect_var_type(data, outcome_column)

  metadata_dir <- path
  if (!dir.exists(metadata_dir)) {
    dir.create(metadata_dir)
  }

  # Comparison Visualizations
  if (outcome_type == "categorical") {
    suppressPackageStartupMessages(require(forcats))
    # Outcome variable visualization
    cat_metadata <- plot_cat_metadata(data, outcome_column)
    cat_metadata_fn <- paste0(file_name, "_dist_", outcome_column, device)
    save_plots(cat_metadata_fn,
      plot = cat_metadata,
      path = metadata_dir, width = width, height = height
    )


    plot_num <- 0
    # Loop through all the columns
    for (col in names(data)) {
      plot_num <- plot_num + 1
      # If the col is the same as the outcome
      if (col == outcome_column) next

      # Get the data type of the current column
      col_type <- detect_var_type(data, col)

      # If it is other, we skip for now
      if (col_type == "other") {
        print(paste0(col, " was not plotted"))
        next
      }

      # categorical and numerical comparisons
      if (col_type == "categorical") {
        comp_metadata <- plot_cat_vs_cat_metadata(data, outcome_column, col)
      } else if (col_type == "numerical") {
        comp_metadata <- plot_cat_vs_num_metadata(data, outcome_column, col)
      }

      # Save Comparison
      comp_metadata_fn <- paste0(
        file_name, plot_num, "_",
        outcome_column, "_vs_", col, device
      )
      save_plots(comp_metadata_fn,
        plot = comp_metadata,
        path = metadata_dir, width = width * 2, height = height
      )
    }
  } else if (outcome_type == "numerical") {
    # Outcome variable visualization
    num_metadata <- plot_num_metadata(data, outcome_column, font_size = 11)
    num_metadata_fn <- paste0(file_name, "_dist_", outcome_column, device)
    save_plots(num_metadata_fn,
      plot = num_metadata, path = metadata_dir,
      width = width, height = height
    )
    plot_num <- 0
    # Loop through all of the columns
    for (col in names(data)) {
      plot_num <- plot_num + 1
      # If the col is the same as the outcome
      if (col == outcome_column) next

      # Get the data type of the current column
      col_type <- detect_var_type(data, col)

      # If it is other, we skip for now
      if (col_type == "other") {
        print(paste0(col, " was not plotted"))
        next
      }

      # categorical and numerical comparisons
      if (col_type == "categorical") {
        comp_metadata <- plot_cat_vs_num_metadata(data, col, outcome_column)
      } else if (col_type == "numerical") {
        comp_metadata <- plot_num_vs_num_metadata(data, outcome_column, col)
      }

      comp_metadata_fn <- paste0(
        file_name, plot_num, "_", outcome_column, "_vs_", col, device
      )
      save_plots(
        comp_metadata_fn,
        plot = comp_metadata,
        path = metadata_dir, width = width * 2, height = height
      )
    }
  } else if (outcome_type == "other") {
    print("Outcome variable has too many levels")
  }
}

source(file.path(R_SCRIPTS_PATH, "utils.R"))

sci_format <- function(x) {
  suppressPackageStartupMessages(require(scales))
  ifelse((abs(x) < 1 & abs(x) > 0 & floor(log10(abs(x))) <= -2) | abs(x) >= 10000,
    formatC(x, format = "e", digits = 2), formatC(x, format = "f", digits = 2)
  )
}

#' `prepare_data_for_hist()` calculates row sums and columns sums for 1 or 2 data frames.
#'
#' Note: If you leave x2 blank, it will be NULL and not calculate.
#'
#' @param x1 data.frame: 1st or only data frame to have sums be calculated
#' @param x2 data.frame: 2nd data frame to have sums be calculated. Default is NULL.
#'
#' @returns list: a list of all the sums; 1st two values in the list are for x1, the next two for x2.
#'
prepare_data_for_hist <- function(x1, x2 = NULL) {
  # Calculate row sum and col sums of dataset 1
  data1_sample <- rowSums(x1)
  data1_feature <- colSums(x1)

  list_sums <- list(data1_sample, data1_feature)

  # Calculates row and col sums for second dataset if it is given Allows for
  # situations with only a single dataset
  if (!is.null(x2)) {
    data2_sample <- rowSums(x2)
    data2_feature <- colSums(x2)

    list_sums <- append(list_sums, list(data2_sample, data2_feature))
  }

  return(list_sums)
}

#' `non_zero_sums()` calculates row sums and columns sums for non-zero values in 1 or 2 data frames.
#'
#' Note: If you leave x2 blank, it will be NULL and not calculate.
#'
#' @param x1 (data.frame) 1st or only data frame to have non-zero sums be calculated.
#' @param x2 (data.frame) 2nd data frame to have non-zero sums be calculated. Default is NULL.
#'
#' @returns (list) of all the sums; 1st value in the list are for x1, the 2nd is for x2 if used.
#'
non_zero_sums <- function(x1, x2 = NULL) {
  # Sum all non-zero values for a dataset
  x1_non_zero_row <- rowSums(x1 != 0)
  x1_non_zero_col <- colSums(x1 != 0)
  sums <- list(x1_non_zero_row, x1_non_zero_col)

  # Allows for situations with only a single dataset
  if (!is.null(x2)) {
    x2_non_zero_row <- rowSums(x2 != 0)
    x2_non_zero_col <- colSums(x2 != 0)
    sums <- append(sums, list(x2_non_zero_row, x2_non_zero_col))
  }

  # Returns list of non_zero rowSums
  return(sums)
}

#' `prepare_axis_label()` adjusts axis label names to include log transformation.
#'
#' @param label chr: the axis label to be adjusted.
#' @param log_type chr: the log transformation being applied.
#'
#' @returns chr: the new label with the transformation added.
#'
prepare_axis_label <- function(label, log_type) {
  if (grepl("1p", log_type)) {
    if (grepl("_1p", log_type)) {
      label_log <- gsub("_1p", "", log_type)
      label <- paste0(label, " (", label_log, "(x+1))")
    } else {
      label <- paste0(label, " (ln(x+1))")
    }
  } else if (log_type == "log") {
    label <- paste0(label, " (ln)")
  } else {
    label <- paste0(label, " (", log_type, ")")
  }
  return(label)
}

log_transformation <- function(x, log_type) {
  if (grepl("1p", log_type)) {
    if (grepl("_1p", log_type)) {
      label_log <- gsub("_1p", "", log_type)
      if (label_log == "log10") {
        return(log10(1 + x))
      } else if (label_log == "log2") {
        return(log2(1 + x))
      }
    } else {
      return(log(1 + x))
    }
  } else if (log_type == "log") {
    return(log(x))
  } else if (log_type == "log2") {
    return(log2(x))
  } else if (log_type == "log10") {
    return(log10(x))
  }
  return(x)
}

#'
#' Transformations functions for different transformation functions
#' They are called by scale_*_continuous when we enter the name (first argument in trans_new())
#' They just need to be here, don't need to be called any other time.
#'

#' `log1p()` is a transformation function for log with x + 1 as an input
log2_1p <- function(x) {
  log2(1 + x)
}

#' `log2_1p_trans()` is a transformation function for log base 2 with x + 1 as an input
log2_1p_trans <- function() {
  suppressPackageStartupMessages(require(scales))

  trans_new("log2_1p",
    transform = log2_1p, inverse = function(x) {
      2^x - 1
    }, breaks = trans_breaks(log2_1p, function(x) 2^x - 1),
    domain = c(0, Inf)
  )
}

#' `log10_1p()` is a transformation function for log base 10 with x + 1 as an input
log10_1p <- function(x) {
  log10(1 + x)
}

#' `log10_1p_trans()` is a transformation function for log base 10 with x + 1 as an input
log10_1p_trans <- function() {
  suppressPackageStartupMessages(require(scales))

  trans_new("log10_1p",
    transform = log10_1p, inverse = function(x) {
      10^x - 1
    }, breaks = trans_breaks(log10_1p, function(x) 10^x - 1),
    domain = c(0, Inf)
  )
}

#'
#' `color_select()` prepares a vector of colours to use in a ggplot
#'
#' Note: Requires RColorBrewer and circulize packages
#'
#' @details It will use RColorBrewer's sets of colours as the base for the vector
#' If the number of colours needed are <= the number of colors in the set,
#' then the colours are used directly from the set
#' Else, the function will generate colors in between using a colour ramp
#'
#' @param levels (int) number of colours that are to be returned
#' @param col_set (chr) the RColorBrewer set that is to be used, and only those sets
#'  ('Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent')
#'
#' @returns (vec) a vector of colours
#'
#' @examples
#' \dontrun{
#' colors <- color_select(5, "Set3")
#' }
color_select <- function(levels, col_set = "Set1") {
  col_set <- match.arg(col_set, c(
    "Set1", "Set2", "Set3", "Pastel2", "Pastel1",
    "Paired", "Dark2", "Accent"
  ))

  if (col_set %in% c("Set1", "Pastel1")) {
    num_col <- 9
  } else if (col_set %in% c("Set3", "Paired")) {
    num_col <- 12
  } else {
    num_col <- 8
  }

  if (levels > num_col) {
    at <- seq(0, levels, length.out = num_col)
    color_fn <- circlize::colorRamp2(at, RColorBrewer::brewer.pal(num_col, col_set))
    colors <- color_fn(1:levels)
  } else {
    color_fn <- RColorBrewer::brewer.pal(num_col, col_set)
    colors <- color_fn[1:levels]
  }
  return(colors)
}


#' Generate a simple histogram for one variable.
#'
#' `generate_histogram()` creates a simple histogram for a single numerical variable.
#'
#' Note: requires packages ggplot2 and rlang.
#'
#' @param data (data.frame or vector) a data frame that the function is obtaining the data from or a vector of data
#'  If you pass a vector, it will be made into a data.frame with the label as the name of the column.
#' @param column (chr) the column with the data that is to be used in the histogram.
#'  Default is value so label doesn't need to be provided and the function works.
#' @param xlab (chr) name of the x-axis. Default is 'X'.
#' @param ylab (chr) name of the y-axis. Default is 'Frequency'.
#' @param title (chr) title of the figure. Default is 'Histogram'.
#' @param bins (int) number of bins for the histogram. Default is 30.
#' @param font_size (dbl) size of the font for the plot. Default is 8.
#' @param alpha (dbl) Opacity of bars. Default is 0.6.
#' @param col_fill (chr) primary colour of the bars. Default is 'grey40'.
#' @param col_outline (chr) colour of the outline of the bars. Default is 'black'.
#' @param xlog (chr) logarithmic transformation of the x-axis.
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'
#' @param ylog (chr) logarithmic transformation of the y-axis. Default is NULL (none).
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'
#'
#' @returns the ggplot build of the final histogram.
#'
#' @examples
#' \dontrun{
#' generate_histogram(mtcars, wt)
#'
#' generate_histogram(mtcars, wt,
#'   xlab = "Weights", ylab = "Frequency",
#'   title = "Weights of Cars", bins = 30,
#'   col_fill = "red", col_outline = "black", xlog = "log2",
#'   ylog = NULL
#' )
#' }
generate_histogram <- function(
    data, column = NULL, xlab = "X", ylab = "Frequency",
    title = "Histogram", bins = 30, font_size = 8, alpha = 0.6,
    col_fill = "grey40", col_outline = "black",
    xlog = NULL, ylog = NULL) {
  data <- convert_to_dataframe(data)

  column <- get_default_columns(data, column)
  if (is.null(column)) {
    data <- reshape2::melt(data)
    column <- "value"
  }
  data <- validate_data(data, column)

  if (!is.null(xlog)) {
    xlog <- match.arg(xlog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    xlab <- prepare_axis_label(xlab, xlog)
  }
  if (!is.null(ylog)) {
    ylog <- match.arg(ylog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    ylab <- prepare_axis_label(ylab, ylog)
  }

  suppressPackageStartupMessages(require(ggplot2))

  ggplot(data, aes(x = .data[[column]])) +
    geom_histogram(
      bins = bins, fill = col_fill,
      color = col_outline, alpha = alpha
    ) +
    labs(x = xlab, y = ylab, title = title) +
    theme_bw() +
    theme(text = element_text(size = font_size), plot.title = element_text(hjust = 0.5)) +
    {
      if (!is.null(xlog)) {
        scale_x_continuous(trans = xlog)
      }
    } +
    {
      if (!is.null(ylog)) {
        scale_y_continuous(trans = ylog)
      }
    }
}

#' Generate a histogram to compare two sets of values
#'
#' `generate_comparison_histogram()` creates a histogram that compares values from two groups. Typically a before and after some transformation or filtering, but could also just be two categories.
#'
#' Note: requires packages ggplot2, RColorBrewer.
#'
#' @param data1 (vector) data of the 1st group.
#' @param data2 (vector) data of the 2nd group.
#' @param column1 (chr) name of column containing first set of data
#' @param column2 (chr) name of column containing second set of data
#' @param xlab (chr) name of the x-axis.
#' @param ylab (chr) name of the y-axis. Default is 'Count'.
#' @param title (chr) title of the figure. Default is 'Comparison Histogram'
#' @param bins (int) number of bins for the histogram. Default is 30.
#' @param alpha (double) opacity of the histograms. Value between 0 and 1. Default is 0.6.
#' @param legend_title (chr) name of the legend. Default is 'Feature Selection'.
#' @param legend_position (chr) placement of the legend in the figure.
#'  Options indude: (default) 'top', 'bottom', 'left', 'right'.
#' @param subplot_title1 (chr) name of the values from the 1st dataset. Default is 'Before'.
#' @param subplot_title2 (chr) name of the values from the 2nd dataset. Default is 'After'.
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param cols (chr (vec)) vector of colors that you wish to use. Default to NULL and other colours are produced using the set in col_set.
#' @param col_outline (chr) colour of the border for the bars. Default is 'black'.
#' @param xlog (chr) logarithmic transformation of the x-axis.
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10'.
#' @param ylog (chr) logarithmic transformation of the y-axis. Default is NULL (none).
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10'.
#'
#' @returns the ggplot build of the final histogram.
#'
#' @examples
#' \dontrun{
#' control <- PlantGrowth$weight[PlantGrowth$group == "ctrl"]
#' treat1 <- PlantGrowth$weight[PlantGrowth$group == "trt1"]
#' generate_comparison_histogram(control, treat1,
#'   xlab = "Weights",
#'   title = "Control VS. Treatment: Plant Weights"
#' )
#' }
generate_comparison_histogram <- function(
    data1, data2, column1 = NULL, column2 = NULL,
    xlab = NULL, ylab = "Count", title = "Comparison Histogram", bins = 30, alpha = 0.6,
    legend_title = "Feature Selection", legend_position = "top", subplot_title1 = "Before",
    subplot_title2 = "After", col_set = "Set1", cols = NULL, col_outline = "black", xlog = NULL,
    ylog = NULL, ...) {
  suppressPackageStartupMessages(require(ggplot2))

  data1 <- convert_to_dataframe(data1)

  data2 <- convert_to_dataframe(data2)

  column1 <- get_default_columns(data1, column1)
  if (is.null(column1)) {
    data1 <- reshape2::melt(data1)
    column1 <- "value"
  }
  data1 <- validate_data(data1, column1)

  column2 <- get_default_columns(data2, column2)
  if (is.null(column2)) {
    data2 <- reshape2::melt(data2)
    column2 <- "value"
  }
  data2 <- validate_data(data2, column1)

  if (is.null(xlab)) {
    if (is.null(column1)) {
      xlab <- "Values"
    } else {
      xlab <- column1
    }
  }

  if (!is.null(xlog)) {
    xlog <- match.arg(xlog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    xlab <- prepare_axis_label(xlab, xlog)
  }
  if (!is.null(ylog)) {
    ylog <- match.arg(ylog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    ylab <- prepare_axis_label(ylab, ylog)
  }

  data_frame <- rbind(data.frame(value = data1, category = subplot_title1), data.frame(
    value = data2,
    category = subplot_title2
  ))
  data_frame$category <- factor(data_frame$category, levels = c(subplot_title1, subplot_title2))

  # Default Colours
  if (is.null(cols)) {
    cols <- color_select(2, col_set = col_set)
    names(cols) <- c(subplot_title1, subplot_title2)
  }

  ggplot(data_frame, aes(x = .data[[column1]], fill = category)) +
    geom_histogram(
      bins = bins,
      alpha = alpha, position = "identity", color = col_outline
    ) +
    scale_fill_manual(values = c(
      cols[1],
      cols[2]
    ), name = legend_title) +
    labs(x = xlab, title = title) +
    theme_bw() +
    theme(
      legend.position = legend_position, text = element_text(size = 8),
      axis.title = element_text(size = 6), legend.text = element_text(size = 6),
      legend.key.size = unit(1, "line"), legend.title = element_text(size = 7)
    ) +
    {
      if (!is.null(xlog)) {
        scale_x_continuous(trans = xlog)
      }
    } +
    {
      if (!is.null(ylog)) {
        scale_y_continuous(trans = ylog)
      }
    }
}

#' Generate a simple density plot for one variable.
#'
#' `generate_density()` creates a simple density plot for a single numerical variable.
#'
#' Note: requires packages ggplot2.
#'
#' @param data (data.frame) a data frame that the function is obtaining the data from.
#' @param column (chr) the column with the data that is to be used in the density plot.
#' @param xlab (chr) name of the x-axis. Default is 'X'.
#' @param ylab (chr) name of the y-axis. Default is 'Density'.
#' @param title (chr) title of the figure. Default is 'Density Plot'.
#' @param col_fill (chr) primary colour of the bars. Default is 'grey40'.
#' @param col_outline (chr) colour of the outline of the bars. Default is 'black'.
#' @param adjust (dbl) adjust bandwidth, which determines how precise (lower values) or smooth (higher values) the density plot is. Default is 1.
#' @param alpha (dbl) opacity of the density plot. Default is 0.8.
#' @param xlog (chr) logarithmic transformation of the x-axis.
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'
#'
#' @returns the ggplot build of the final density plot.
#'
#' @examples
#' \dontrun{
#' generate_density(mtcars, wt)
#'
#' generate_density(mtcars, wt,
#'   xlab = "Weights", ylab = "Density",
#'   title = "Weights of Cars",
#'   col_fill = "red", col_outline = "black",
#'   adjust = 0.5, alpha = 0.8, xlog = "log2"
#' )
#' }
generate_density <- function(
    data, column = NULL, xlab = "X", ylab = "Density",
    title = "Density Plot", col_fill = "grey40", col_outline = "black", adjust = 1,
    alpha = 0.6, xlog = NULL) {
  suppressPackageStartupMessages(require(ggplot2))

  data <- convert_to_dataframe(data)

  column <- get_default_columns(data, column)
  if (is.null(column)) {
    data <- reshape2::melt(data)
    column <- "value"
  }
  data <- validate_data(data, column)

  if (!is.null(xlog)) {
    xlog <- match.arg(xlog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    xlab <- prepare_axis_label(xlab, xlog)
  }

  if (!is.data.frame(data)) {
    data <- convert_to_dataframe(data)
    colnames(data) <- column
  }

  ggplot(data, aes(x = .data[[column]])) +
    geom_density(
      fill = col_fill, color = col_outline,
      adjust = adjust, alpha = alpha
    ) +
    labs(x = xlab, y = ylab, title = title) +
    theme_bw() +
    theme(plot.title = element_text(hjust = 0.5)) +
    {
      if (!is.null(xlog)) {
        scale_x_continuous(trans = xlog)
      }
    }
}

#' Generate a density plot to compare two sets of values.
#'
#' `generate_comparison_density()` creates a density plot that compares values from two groups. Typically a before and after some transformation or filtering, but could also just be two categories.
#'
#' Note: requires packages ggplot2, RColorBrewer.
#'
#' @param data1 (vector) data of the 1st group.
#' @param data2 (vector) data of the 2nd group.
#' @param column1 (chr) name of column containing first set of data
#' @param column2 (chr) name of column containing second set of data
#' @param xlab (chr) name of the x-axis.
#' @param ylab (chr) name of the y-axis. Default is 'Count'.
#' @param title (chr) title of the figure. Default is 'Comparison Density Plot'
#' @param legend_title (chr) name of the legend. Default is 'Feature Selection'.
#' @param legend_position (chr) placement of the legend in the figure.
#'  Options include: (default) 'top', 'bottom', 'left', 'right'.
#' @param subplot_title1 (chr) name of the values from the 1st dataset. Default is 'Before'.
#' @param subplot_title2 (chr) name of the values from the 2nd dataset. Default is 'After'.
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param cols (chr (vec)) vector of colors that you wish to use. Default to NULL and other colours are produced using the set in col_set.
#' @param col_outline (chr) colour of the border of the density shape. Default is 'black'.
#' @param adjust (dbl) adjust bandwidth, which determines how precise (lower values) or smooth (higher values) the density plot is. Default is 1.
#' @param alpha (dbl) opacity of the histograms. Value between 0 and 1. Default is 0.6.
#' @param xlog (chr) logarithmic transformation of the x-axis.
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'.
#'
#' @returns the ggplot build of the final density plot.
#'
#' @examples
#' \dontrun{
#' control <- PlantGrowth$weight[PlantGrowth$group == "ctrl"]
#' treat1 <- PlantGrowth$weight[PlantGrowth$group == "trt1"]
#' generate_comparison_density(control, treat1,
#'   xlab = "Weights",
#'   title = "Control VS. Treatment: Plant Weights"
#' )
#' }
generate_comparison_density <- function(
    data1, data2, column1 = NULL, column2 = NULL,
    xlab = NULL, ylab = "Count", title = "Comparison Density Plot", legend_title = "Feature Selection",
    legend_position = "top", subplot_title1 = "Before", subplot_title2 = "After", col_set = "Set1",
    cols = NULL, col_outline = "black", adjust = 1, alpha = 0.6, xlog = NULL) {
  suppressPackageStartupMessages(require(ggplot2))
  data1 <- convert_to_dataframe(data1)

  data2 <- convert_to_dataframe(data2)

  column1 <- get_default_columns(data1, column1)
  if (is.null(column1)) {
    data1 <- reshape2::melt(data1)
    column1 <- "value"
  }
  data1 <- validate_data(data1, column1)

  column2 <- get_default_columns(data2, column2)
  if (is.null(column2)) {
    data2 <- reshape2::melt(data2)
    column2 <- "value"
  }
  data2 <- validate_data(data2, column1)

  if (is.null(xlab)) {
    if (is.null(column1)) {
      xlab <- "Values"
    } else {
      xlab <- column1
    }
  }

  if (!is.null(xlog)) {
    xlog <- match.arg(xlog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    xlab <- prepare_axis_label(xlab, xlog)
  }

  data_frame <- rbind(data.frame(value = data1, category = subplot_title1), data.frame(
    value = data2,
    category = subplot_title2
  ))
  data_frame$category <- factor(data_frame$category, levels = c(subplot_title1, subplot_title2))

  if (is.null(cols)) {
    cols <- color_select(2, col_set = col_set)
    names(cols) <- c(subplot_title1, subplot_title2)
  }

  ggplot(data_frame, aes(x = value, fill = category)) +
    geom_density(
      adjust = adjust,
      alpha = alpha, color = col_outline
    ) +
    scale_fill_manual(values = c(
      cols[1],
      cols[2]
    ), name = legend_title) +
    labs(x = xlab, title = title) +
    theme_bw() +
    theme(
      legend.position = legend_position, text = element_text(size = 8),
      axis.title = element_text(size = 6), legend.text = element_text(size = 6),
      legend.key.size = unit(1, "line"), legend.title = element_text(size = 7)
    ) +
    {
      if (!is.null(xlog)) {
        scale_x_continuous(trans = xlog)
      }
    }
}

#'
#' `generate_barplot()` creates a bar plot using ggplot2
#'
#' Note: Requires ggplot2 package
#'
#' @details Settings available for both normal or stacked (& proportional stacked) bar plots.
#' adding a groupby variable will make a stacked bar plot and setting prop = T will make proportional bar plot.
#'
#' @param data (data.frame/vector) data frame contained the data of interest or vector with levels (categorical variable)
#' @param y (data.frame or vector) contains the identity values/heights of the bars (ex. counts of the bars pre-calculated)
#' @param group
#' @param label_name (chr) the name of the categorical variable to be used for the bars. Default is 'Labels'.
#' @param value_name (chr) the name of the column containing values for y (pre-calculated counts)
#' @param groupby (chr) the name of the secondary categorical variable to group the bars. Default is NULL.
#' @param xlab (chr) x-axis label. Default is 'X'.
#' @param ylab (chr) y-axis label. Default is 'Count'
#' @param title (chr) plot name/title. Default is 'Bar Plot'
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param cols (chr (vec)) vector of colors that you wish to use. Default to NULL and other colours are produced using the set in col_set.
#' @param col_outline (chr) colour of the outline of the bars. Default is 'grey'.
#' @param col_labels (chr) colour of the labels on the bars. Default is 'black'.
#' @param alpha (dbl) Opacity. Default is 0.6.
#' @param prop (logical) make a stacked barplot a proportional barplot. Default is FALSE.
#' @param add_count_lab (logical) add count labels to bars. Default is TRUE.
#' @param vars_as_entered (logical) leave the variable order as entered, not flipping the values so the variable with more levels makes the bars. Default is FALSE.
#' @param legend_position (chr) position of the legend.
#'  Options Include: (default) 'top', 'bottom', 'left', 'right'
#' @param font_size (dbl) size of the font. Default is 3.25.
#'
#' @returns The ggplot object of the completed plot
#'
#' @examples
#' \dontrun{
#' generate_barplot(mtcars, "gear")
#'
#' generate_barplot(mtcars, "gear",
#'   groupby = "cyl", xlab = "gear", ylab = "Count",
#'   title = "Gear Vs. Carb", col_set = "Set2",
#'   prop = T, add_count_lab = T, vars_as_entered = F,
#'   legend_position = "top", font_size = 4
#' )
#' }
generate_barplot <- function(
    data, y = NULL, group = NULL, label_name = "labels",
    value_name = "values", groupby = "group", xlab = NULL, ylab = NULL, title = "Bar Plot",
    col_set = "Set1", cols = NULL, col_outline = "grey30", col_labels = "black", alpha = 0.6,
    prop = F, add_count_lab = T, vars_as_entered = F, legend_position = "top", font_size = 3.25) {
  suppressPackageStartupMessages(require(ggplot2))

  # Angled text threshold
  VERT_LEVELS_MIN <- 9 # minimum number of levels
  VERT_WORD_MIN <- 7 # minimum length of largest label name

  data <- convert_to_dataframe(data)
  label_name <- get_default_columns(data, label_name)
  data <- validate_data(data, label_name)

  if (!is.null(y)) {
    y <- convert_to_dataframe(y)
    value_name <- get_default_columns(y, value_name)
    # check if value_name is in y or add it if possible, otherwise error
    y <- validate_data(y, value_name)
    data <- concatenate_datasets(data, y, how = "horizontal")
  }

  if (!is.null(group)) {
    group <- convert_to_dataframe(group)
    groupby <- get_default_columns(group, groupby)
    group <- validate_data(group, groupby)
    data <- concatenate_datasets(data, group, how = "horizontal")
  }

  if (is.null(xlab)) {
    xlab <- label_name
  }

  # Check that the variable is a character
  if (!is.character(data[[label_name]])) {
    data[[label_name]] <- as.character(data[[label_name]])
  }
  cat_lvls <- length(unique(data[[label_name]]))

  if (!is.null(value_name) && value_name %in% colnames(data)) {
    data <- data[, c(label_name, value_name)]
    if (is.null(ylab)) {
      ylab <- value_name
    }
    sorted_inds <- order(data[[value_name]], decreasing = TRUE)
    data <- data[sorted_inds, ]
    max_length <- max(nchar(unique(na.omit(data[[label_name]]))))
    data[[label_name]] <- factor(data[[label_name]], levels = data[[label_name]])
    levels <- 1
    if (is.null(cols)) {
      cols <- color_select(levels, col_set)
    }
    the_plot <- ggplot(data, aes(x = .data[[label_name]], y = .data[[value_name]])) +
      geom_bar(stat = "identity", color = col_outline, fill = cols, alpha = alpha) +
      theme_bw() +
      labs(x = xlab, y = ylab, title = title) +
      theme(
        legend.position = legend_position,
        plot.title = element_text(hjust = 0.5)
      ) +
      {
        if (cat_lvls >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN) {
          theme(axis.text.x = element_text(angle = 60, hjust = 1))
        }
      } +
      {
        if (add_count_lab) {
          geom_text(aes(label = sci_format(.data[[value_name]])),
            stat = "identity",
            position = position_stack(vjust = 0.5), color = col_labels, size = font_size
          )
        }
      }
  } else {
    if (is.null(ylab)) {
      ylab <- "Count"
    }
    # If a groupby value has been passed, the function sets up for a stacked
    # barplot
    if (!is.null(groupby) && groupby %in% colnames(data)) {
      stacked <- TRUE

      # Check that the variable is a character
      if (!is.character(data[[groupby]])) {
        data[[groupby]] <- as.character(data[[groupby]])
      }

      # settings for plot type and labels Proportional or Stack
      if (prop) {
        position_set <- "fill"
        position_func <- position_fill(vjust = 0.5)

        # Won't change the name if a custom label is given
        if (ylab == "Count") {
          ylab <- "Proportion"
        }
      } else {
        position_set <- "stack"
        position_func <- position_stack(vjust = 0.5)
      }

      # Calculate Levels
      groupby_lvls <- length(unique(data[[groupby]]))
      max_length <- max(nchar(unique(na.omit(data[[label_name]]))))

      # Function will make the variable with more levels the bars of the plot
      # Unless it is specified to leave it as is
      if (!vars_as_entered) {
        # if grouby is larger, swap the values
        if (groupby_lvls > cat_lvls) {
          temp <- label_name
          label_name <- groupby
          groupby <- temp
          xlab <- label_name

          levels <- cat_lvls
          cat_lvls <- groupby_lvls
          max_length <- max(nchar(unique(na.omit(data[[label_name]]))))
        } else {
          levels <- groupby_lvls
        }
      } else {
        levels <- groupby_lvls
      }
    } else {
      stacked <- FALSE
      cat_lvls <- length(unique(data[[label_name]]))
      max_length <- max(nchar(unique(na.omit(data[[label_name]]))))
      levels <- 1
    }

    if (is.null(cols)) {
      cols <- color_select(levels, col_set)
    }

    if (stacked) {
      the_plot <- ggplot(data, aes(
        x = forcats::fct_infreq(.data[[label_name]]),
        fill = forcats::fct_rev(forcats::fct_infreq(.data[[groupby]]))
      )) +
        geom_bar(position = position_set, stat = "count", color = col_outline, alpha = alpha) +
        theme_bw() +
        labs(
          x = xlab, y = ylab, color = groupby, fill = groupby,
          title = title
        ) +
        theme(legend.position = legend_position, plot.title = element_text(hjust = 0.5)) +
        scale_fill_manual(values = cols) +
        {
          if (cat_lvls >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        } +
        {
          if (add_count_lab) {
            geom_text(aes(label = after_stat(count)),
              stat = "count", position = position_func,
              color = col_labels, size = font_size
            )
          }
        }
    } else {
      the_plot <- ggplot(data, aes(x = forcats::fct_infreq(.data[[label_name]]))) +
        geom_bar(stat = "count", color = col_outline, alpha = alpha) +
        theme_bw() +
        labs(x = xlab, y = ylab, title = title) +
        theme(
          legend.position = legend_position,
          plot.title = element_text(hjust = 0.5)
        ) +
        {
          if (cat_lvls >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        } +
        {
          if (add_count_lab) {
            geom_text(aes(label = after_stat(count)),
              stat = "count", position = position_stack(vjust = 0.5),
              color = col_labels, size = font_size
            )
          }
        }
    }
  }
  return(the_plot)
}

#'
#' `generate_boxplot()` creates a violin plot using ggplot2
#'
#' Note: Requires ggplot2
#'
#' @param data (data.frame or vector) data frame containing the variable or numerical data
#' @param labels (data.frame or vector) vector (or data frame) containing the categorical data
#' @param column (chr) name of numerical variable column.
#' @param label_name (chr) name of categorical variable.
#' @param xlab (chr) label for categorical axis.
#' @param ylab (chr) label for numerical axis.
#'  Note: You don't need to change the x and y labels around if horizontal_plot is TRUE, the function will change them automatically.
#' @param title (chr) title of the plot. Default is 'Violin Plot'
#' @param legend_position (chr) position of the legend.
#'  Options Include: (default) 'top', 'bottom', 'left', 'right'
#' @param add_box (logical) Add boxplots on top of violin plots. Default is TRUE
#' @param horizontal_plot (logical) if you want the boxplots to be running horizontally, set to TRUE. Default is FALSE.
#' @param order (logical) if you want the violin plots ordered by median. Default is FALSE.
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options Include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param cols (chr (vec)) vector of colors that you wish to use. Default to NULL and other colours are produced using the set in col_set.
#' @param alpha (dbl) Opacity. Default is 0.6.
#' @param log_num (chr) logarithmic transformation of the numerical axis (y).
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'.
#'
#' @returns The ggplot object of the completed plot
#'
#' @examples
#' \dontrun{
#' generate_boxplot(iris, column = "Petal.Length", label_name = "Species")
#'
#' generate_boxplot(iris,
#'   column = "Petal.Length", label_name = "Species",
#'   ylab = "Petal Length", xlab = "Species", horizontal_plot = T
#' )
#' }
generate_boxplot <- function(
    data, labels = NULL, column = NULL, label_name = "labels",
    xlab = NULL, ylab = NULL, title = "Boxplot", legend_position = "top", horizontal_plot = F,
    order = F, col_set = "Set1", cols = NULL, alpha = 0.6, log_num = NULL) {
  suppressPackageStartupMessages(require(ggplot2))

  # Angled text threshold
  VERT_LEVELS_MIN <- 9 # minimum number of levels
  VERT_WORD_MIN <- 7 # minimum length of largest label name

  data <- convert_to_dataframe(data)

  if (!is.null(labels)) {
    labels <- convert_to_dataframe(labels)
    label_name <- get_default_columns(labels, label_name)
    labels <- validate_data(labels, label_name)
  }

  if (is.null(column) && ncol(data) > 2 && !is.null(label_name)) {
    suppressPackageStartupMessages(require(reshape2))

    if (!is.null(labels)) {
      data <- concatenate_datasets(data, labels, how = "horizontal")
    }
    data <- reshape2::melt(data, id.vars = label_name)
    column <- names(data)[3]
  } else {
    column <- get_default_columns(data, column)
    data <- validate_data(data, column)
    if (!is.null(labels)) {
      data <- concatenate_datasets(data, labels, how = "horizontal")
    }
  }

  if (is.null(xlab)) {
    xlab <- label_name
  }

  if (is.null(ylab)) {
    ylab <- column
  }

  if (!is.null(log_num)) {
    log_num <- match.arg(log_num, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    ylab <- prepare_axis_label(ylab, log_num)
  }

  if (!is.null(label_name) && label_name %in% colnames(data)) {
    # Make sure label_name is categorical
    if (!is.character(data[[label_name]])) {
      data[[label_name]] <- as.character(data[[label_name]])
    }

    levels <- length(unique(data[[label_name]]))
    max_length <- max(nchar(unique(na.omit(data[[label_name]]))))

    if (is.null(cols)) {
      cols <- color_select(levels, col_set)
    }

    if (order) {
      the_plot <- ggplot(data, aes(x = forcats::fct_reorder(.data[[label_name]],
        .data[[column]],
        .fun = median
      ), y = .data[[column]], fill = .data[[label_name]])) +
        geom_boxplot(alpha = alpha) +
        theme_bw() +
        scale_fill_manual(values = cols) +
        labs(x = xlab, y = ylab, title = title) +
        theme(
          legend.position = legend_position,
          plot.title = element_text(hjust = 0.5)
        ) +
        {
          if (!is.null(log_num)) {
            scale_y_continuous(trans = log_num)
          }
        } +
        {
          if (horizontal_plot) {
            coord_flip()
          }
        } +
        {
          if ((levels >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN)) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        }
    } else {
      the_plot <- ggplot(data, aes(
        x = .data[[label_name]], y = .data[[column]],
        fill = .data[[label_name]]
      )) +
        geom_boxplot(alpha = alpha) +
        theme_bw() +
        scale_fill_manual(values = cols) +
        labs(x = xlab, y = ylab, title = title) +
        theme(
          legend.position = legend_position,
          plot.title = element_text(hjust = 0.5)
        ) +
        {
          if (!is.null(log_num)) {
            scale_y_continuous(trans = log_num)
          }
        } +
        {
          if (horizontal_plot) {
            coord_flip()
          }
        } +
        {
          if ((levels >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN)) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        }
    }
  } else {
    the_plot <- ggplot(data, aes(x = 1, y = .data[[column]])) +
      geom_boxplot(alpha = alpha) +
      theme_bw() +
      labs(x = xlab, y = ylab, title = title) +
      theme(
        legend.position = legend_position,
        plot.title = element_text(hjust = 0.5)
      ) +
      {
        if (!is.null(log_num)) {
          scale_y_continuous(trans = log_num)
        }
      } +
      {
        if (horizontal_plot) {
          coord_flip()
        }
      }
  }
  return(the_plot)
}

#'
#' `generate_violin()` creates a violin plot using ggplot2
#'
#' Note: Requires ggplot2
#'
#' @param data (data.frame or vector) data frame containing the variable or numerical data
#' @param labels (data.frame or vector) vector (or data frame) containing the categorical data
#' @param column (chr) name of numerical variable column.
#' @param label_name (chr) name of categorical variable.
#' @param xlab (chr) label for categorical axis.
#' @param ylab (chr) label for numerical axis.
#'  Note: You don't need to change the x and y labels around if horizontal_plot is TRUE, the function will change them automatically.
#' @param title (chr) title of the plot. Default is 'Violin Plot'
#' @param legend_position (chr) position of the legend.
#'  Options Include: (default) 'top', 'bottom', 'left', 'right'
#' @param add_box (logical) Add boxplots on top of violin plots. Default is TRUE
#' @param horizontal_plot (logical) if you want the boxplots to be running horizontally, set to TRUE. Default is FALSE.
#' @param order (logical) if you want the violin plots ordered by median. Default is FALSE.
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options Include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param cols (chr (vec)) vector of colors that you wish to use. Default to NULL and other colours are produced using the set in col_set.
#' @param alpha (dbl) Opacity. Default is 0.6.
#' @param log_num (chr) logarithmic transformation of the numerical axis (y).
#'   Options include: (default) NULL (none), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'.
#'
#' @returns The ggplot object of the completed plot
#'
#' @examples
#' \dontrun{
#' generate_violin(iris, column = "Petal.Length", label_name = "Species")
#'
#' generate_violin(iris,
#'   column = "Petal.Length", label_name = "Species",
#'   ylab = "Petal Length", xlab = "Species", horizontal_plot = T
#' )
#' }
generate_violin <- function(
    data, labels = NULL, column = NULL, label_name = "labels",
    ylab = NULL, xlab = NULL, ylim = NULL, title = "Violin Plot",
    legend_position = "top", add_box = TRUE, horizontal_plot = FALSE,
    order = FALSE, col_set = "Set1", cols = NULL, alpha = 0.6,
    log_num = NULL, show_outliers = TRUE) {
  suppressPackageStartupMessages(require(ggplot2))

  # Angled text threshold
  VERT_LEVELS_MIN <- 9 # minimum number of levels
  VERT_WORD_MIN <- 7 # minimum length of largest label name

  data <- convert_to_dataframe(data)

  if (!is.null(labels)) {
    labels <- convert_to_dataframe(labels)
    label_name <- get_default_columns(labels, label_name)
    labels <- validate_data(labels, label_name)
  }

  if (is.null(column) && ncol(data) > 2 && !is.null(label_name)) {
    suppressPackageStartupMessages(require(reshape2))
    # melt the data
    if (!is.null(labels)) {
      data <- concatenate_datasets(data, labels, how = "horizontal")
    }
    data <- reshape2::melt(data, id.vars = label_name)
    column <- names(data)[3]
  } else {
    column <- get_default_columns(data, column)
    data <- validate_data(data, column)
    if (!is.null(labels)) {
      data <- concatenate_datasets(data, labels, how = "horizontal")
    }
  }


  if (is.null(xlab) && !is.null(label_name) && label_name %in% colnames(data)) {
    xlab <- label_name
  }

  if (is.null(ylab)) {
    ylab <- column
  }

  if (!is.null(log_num)) {
    log_num <- match.arg(log_num, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    # ylab <- prepare_axis_label(ylab, log_num)
    data[[column]] <- log_transformation(data[[column]], log_num)
  }

  if (!is.null(label_name) && label_name %in% colnames(data)) {
    # Make sure label_column is categorical
    if (!is.character(data[[label_name]])) {
      data[[label_name]] <- as.character(data[[label_name]])
    }

    levels <- length(unique(data[[label_name]]))
    max_length <- max(nchar(unique(na.omit(data[[label_name]]))))

    if (is.null(cols)) {
      cols <- color_select(levels, col_set)
    }

    if (order) {
      the_plot <- ggplot(data, aes(x = forcats::fct_reorder(.data[[label_name]],
        .data[[column]],
        .fun = median
      ), y = .data[[column]], fill = .data[[label_name]])) +
        geom_violin(alpha = alpha) +
        {
          if (add_box) {
            geom_boxplot(
              width = 0.2, color = "black", outlier.shape = 1,
              fill = NA, outlier.fill = "black", alpha = alpha,
              outliers = show_outliers
            )
          }
        } +
        theme_bw() +
        scale_fill_manual(values = cols) +
        labs(
          x = xlab, y = ylab,
          title = title
        ) +
        theme(legend.position = legend_position, plot.title = element_text(hjust = 0.5)) +
        # {
        #   if (!is.null(log_num)) {
        #     scale_y_continuous(trans = log_num)
        #   }
        # } +
        {
          if (!is.null(ylim)) {
            ylim(ylim[[1]], ylim[[2]])
          }
        } +
        {
          if (horizontal_plot) {
            coord_flip()
          }
        } +
        {
          if ((levels >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN)) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        }
    } else {
      the_plot <- ggplot(data, aes(
        x = .data[[label_name]], y = .data[[column]],
        fill = .data[[label_name]]
      )) +
        geom_violin(alpha = alpha) +
        {
          if (add_box) {
            geom_boxplot(
              width = 0.7, color = "black", outlier.shape = 1, outlier.size = 0.5,
              fill = NA, outlier.fill = "black", alpha = alpha, outliers = show_outliers
            )
          }
        } +
        theme_bw() +
        scale_fill_manual(values = cols) +
        labs(
          x = xlab, y = ylab,
          title = title
        ) +
        theme(legend.position = legend_position, plot.title = element_text(hjust = 0.5)) +
        # {
        #   if (!is.null(log_num)) {
        #     scale_y_continuous(trans = log_num)
        #   }
        # } +
        {
          if (!is.null(ylim)) {
            ylim(ylim[[1]], ylim[[2]])
          }
        } +
        {
          if (horizontal_plot) {
            coord_flip()
          }
        } +
        {
          if ((levels >= VERT_LEVELS_MIN || max_length >= VERT_WORD_MIN)) {
            theme(axis.text.x = element_text(angle = 60, hjust = 1))
          }
        }
    }
  } else {
    # generate a single violin plot
    the_plot <- ggplot(data, aes(x = 1, y = .data[[column]])) +
      geom_violin(fill = "grey40", alpha = alpha) +
      {
        if (add_box) {
          geom_boxplot(
            width = 0.2, color = "black", outlier.shape = 1,
            fill = NA, outlier.fill = "black", alpha = alpha
          )
        }
      } +
      theme_bw() +
      labs(x = xlab, y = ylab, title = title) +
      theme(
        legend.position = legend_position,
        plot.title = element_text(hjust = 0.5)
      ) +
      {
        if (!is.null(log_num)) {
          scale_y_continuous(trans = log_num)
        }
      } +
      {
        if (horizontal_plot) {
          coord_flip()
        }
      }
  }
  return(the_plot)
}

#'
#' `generate_scatterplot()` creates a scatterplot using ggplot2
#'
#' Note: Requires ggplot2 package
#'
#' @param data (data.frame or vector) data frame containing the variables or data for the x axis.
#' @param y (data.frame or vector) data for the y axis.
#' @param group (data.frame or vector) label data for grouping the x and y by colour.
#' @param xdata (chr) name of column with data for the x-axis.
#' @param ydata (chr) name of column with data for the y-axis.
#' @param groupby (chr) name of categorical variable to group the points. Default is NULL.
#' @param xlab (chr) x-axis label. Default is 'Var 1'.
#' @param ylab (chr) y-axis label. Default is 'Var 2'.
#' @param title (chr) title for the plot. Default is 'Scatterplot'.
#' @param alpha (dbl) opacity of points. Range: 0 to 1. Default is 1.
#' @param col_set (chr) name of RColorBrewer set to be used for colouring.
#'  Options Include: (default) 'Set1', 'Set2', 'Set3', 'Pastel2', 'Pastel1', 'Paired', 'Dark2', 'Accent'
#' @param xlog (chr) log transformation of the x-axis.
#'  Options Include: (default) NULL (None), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'.
#' @param ylog (chr) log transformation of the y-axis.
#'  Options Include: (default) NULL (None), 'log', 'log2', 'log10', 'log1p', 'log2_1p', 'log10_1p'.
#'
#' @returns The ggplot object of the completed plot
#'
#' @examples
#' \dontrun{
#' generate_scatterplot(mtcars, xdata = "wt", ydata = "qsec")
#'
#' generate_scatterplot(iris,
#'   xdata = "Petal.Length", ydata = "Petal.Width",
#'   groupby = "Species", xlab = "Petal Length",
#'   ylab = "Petal Width", title = "Petals (Length VS. Width)",
#'   alpha = 0.75, col_set = "Set2"
#' )
#' }
generate_scatterplot <- function(
    data, y = NULL, group = NULL, xdata = "x", ydata = "y",
    groupby = "group", xlab = NULL, ylab = NULL, title = "Scatterplot", alpha = 1,
    col_set = "Set1", cols = NULL, xlog = NULL, ylog = NULL) {
  suppressPackageStartupMessages(require(ggplot2))
  data <- convert_to_dataframe(data)
  xdata <- get_default_columns(data, xdata)
  data <- validate_data(data, xdata)

  if (!is.null(y)) {
    y <- convert_to_dataframe(y)
    value_name <- get_default_columns(y, ydata)
    y <- validate_data(y, ydata)
    data <- concatenate_datasets(data, y, how = "horizontal")
  } else {
    data <- validate_data(data, ydata)
  }

  if (!is.null(group)) {
    group <- convert_to_dataframe(group)
    groupby <- get_default_columns(group, groupby)
    group <- validate_data(group, groupby)
    data <- concatenate_datasets(data, group, how = "horizontal")
  }

  if (is.null(xlab)) {
    xlab <- xdata
  }

  if (is.null(ylab)) {
    ylab <- ydata
  }

  if (!is.null(xlog)) {
    xlog <- match.arg(xlog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    xlab <- prepare_axis_label(xlab, xlog)
  }
  if (!is.null(ylog)) {
    ylog <- match.arg(ylog, c(
      "log2", "log10", "log", "log2_1p", "log10_1p",
      "log1p"
    ))
    ylab <- prepare_axis_label(ylab, ylog)
  }

  if (!is.null(groupby) && groupby %in% colnames(data)) {
    grouped <- TRUE

    if (!is.character(data[[groupby]])) {
      data[[groupby]] <- as.character(data[[groupby]])
    }

    if (is.null(cols)) {
      levels <- length(unique(data[[groupby]]))
      cols <- color_select(levels, col_set)
    }
  } else {
    grouped <- FALSE
  }

  if (grouped) {
    ggplot(data, aes(x = .data[[xdata]], y = .data[[ydata]], col = .data[[groupby]])) +
      geom_point(alpha = alpha) +
      theme_bw() +
      theme(plot.title = element_text(hjust = 0.5)) +
      scale_color_manual(values = cols) +
      labs(x = xlab, y = ylab, title = title) +
      {
        if (!is.null(xlog)) {
          scale_x_continuous(trans = xlog)
        }
      } +
      {
        if (!is.null(ylog)) {
          scale_y_continuous(trans = ylog)
        }
      }
  } else {
    ggplot(data, aes(x = .data[[xdata]], y = .data[[ydata]])) +
      geom_point(alpha = alpha) +
      theme_bw() +
      theme(plot.title = element_text(hjust = 0.5)) +
      labs(
        x = xlab,
        y = ylab, title = title
      ) +
      {
        if (!is.null(xlog)) {
          scale_x_continuous(trans = xlog)
        }
      } +
      {
        if (!is.null(ylog)) {
          scale_y_continuous(trans = ylog)
        }
      }
  }
}

#' calls all the plots for a single categorical variable
#' @param data (data.frame) data frame containing the data.
#' @param label_name (chr) name of categorical variable.
plot_cat_metadata <- function(data, label_name, title = NULL, ...) {
  if (is.null(title)) {
    title <- paste0("Distribution of ", label_name)
  }
  p <- generate_barplot(data,
    label_name = label_name, xlab = label_name, title = title,
    ...
  )
  return(p)
}

#' calls all the plots for a single numerical variable
#' @param data (data.frame) data frame containing the data.
#' @param num_var (chr) name of numerical variable.
plot_num_metadata <- function(data, num_var, title = NULL, ...) {
  if (is.null(title)) {
    title <- paste0("Distribution of ", num_var)
  }
  p <- generate_histogram(data, num_var, xlab = num_var, title = title, ...)
  return(p)
}

#' Categorical Variable vs Categorical Variable
#' @param data (data.frame) data frame containing the data.
#' @param var1 (chr) name of 1st categorical variable.
#' @param var2 (chr) name of 2nd categorical variable.
plot_cat_vs_cat_metadata <- function(data, var1, var2, title = NULL, ...) {
  suppressPackageStartupMessages(require(patchwork))
  # Categorical vs Categorical
  if (is.null(title)) {
    title <- paste0(var1, " VS. ", var2)
  }
  # Stacked Barplot
  p1 <- generate_barplot(data,
    label_name = var1, groupby = var2, xlab = var1,
    title = NULL, add_count_lab = F, ...
  )
  # Proportional Barplot
  p2 <- generate_barplot(data,
    label_name = var1, xlab = var1, groupby = var2,
    prop = T, title = NULL, ...
  )
  # Grid
  p <- (p1 + p2 + plot_layout(guides = "collect") + plot_annotation(
    title = title,
    theme = theme(plot.title = element_text(hjust = 0.5))
  ) & theme(legend.position = "top"))
  return(p)
}

#' Categorical Variable vs Numerical Variable
#' @param data (data.frame) data frame containing the data.
#' @param cat (chr) name of categorical variable.
#' @param num (chr) name of numerical variable.
plot_cat_vs_num_metadata <- function(data, cat, num, title = NULL, ...) {
  suppressPackageStartupMessages(require(patchwork))
  # Categorical vs Numeric
  if (is.null(title)) {
    title <- paste0(cat, " VS. ", num)
  }
  # Violin Plot
  p <- generate_violin(data, column = num, label_name = cat, title = title, ...)
  return(p)
}

#' Numerical Variable vs Numerical Variable
#' @param data (data.frame) data frame containing the data.
#' @param var1 (chr) name of 1st numerical variable.
#' @param var2 (chr) name of 2nd numerical variable.
plot_num_vs_num_metadata <- function(data, var1, var2, title = NULL, ...) {
  # Numeric vs Numeric
  if (is.null(title)) {
    title <- paste0(var1, " VS. ", var2)
  }
  # Scatterplot
  p <- generate_scatterplot(data,
    xdata = var1, ydata = var2, xlab = var1, ylab = var2,
    title = title, ...
  )
  return(p)
}

# cumNorm <- function(x, p = cumNormStatFast(x)) {
#   normFactors <- calcNormFactors(x, p = p)
#   x$normFactors <- normFactors
#   return(x)
# }
# 
# calcNormFactors <- function(x, p = cumNormStatFast(x)) {
#   xx <- x
#   xx[x == 0] <- NA
#   qs <- rowQuantiles(xx, probs = p, na.rm = TRUE)
#   norm_factors <- apply(xx, 1, function(row, qs) {
#     row <- (row - .Machine$double.eps)
#     sum(row[row <= qs])
#   }, qs)
#   names(norm_factors) <- rownames(x)
#   as.data.frame(norm_factors)
# }
# 
# cumNormMat <- function(x, p = cumNormStatFast(x), sl = 1000) {
#   xx <- x
#   xx[x == 0] <- NA
# 
#   qs <- rowQuantiles(xx, probs = p, na.rm = TRUE)
# 
#   newMat <- apply(xx, 1, function(row, qs) {
#     row <- (row - .Machine$double.eps)
#     sum(row[row <= qs])
#   }, qs)
#   nmat <- sweep(x, 1, newMat / sl, "/")
#   return(nmat)
# }
# 
# cumNormStat <- function(obj, qFlag = TRUE, pFlag = FALSE, rel = .1, ...) {
#   mat <- returnAppropriateObj(obj, FALSE, FALSE)
#   if (any(rowSums(mat) == 0)) stop("Warning: empty feature")
# 
#   smat <- apply(mat, 1, function(row) sort(row, decreasing = FALSE))
#   ref <- colMeans(smat)
# 
#   yy <- mat
#   yy[yy == 0] = NA
# 
#   refS <- sort(ref)
# 
#   k <- which(refS > 0)[1]
#   lo <- (length(refS) - k + 1)
# 
#   if (qFlag) {
#     diffr <- apply(yy, 1, function(row) {
#       refS[k:length(refS)] - quantile(row, probs = seq(0, 1, length.out = lo), na.rm = TRUE)
#     })
#   } else {
#     diffr <- apply(yy, 1, function(row) {
#       refS[k:length(refS)] - approx(sort(row, decreasing = FALSE), n = lo)$y
#     })
#   }
# 
#   diffr2 <- matrixStats::colMedians(abs(diffr), na.rm = TRUE)
# 
#   x <- which(abs(diff(diffr2)) / diffr2[-1] > rel)[1] / length(diffr2)
#   if (x <= 0.50) {
#     message("Default value being used.")
#     x <- 0.50
#   }
# 
#   return(x)
# }
# 
# cumNormStatFast <- function(mat, pFlag = FALSE, rel = .1, ...) {
# 
#   smat <- apply(mat, 1, function(row) {
#     sort(row[which(row > 0)], decreasing = TRUE)
#   })
# 
#   leng <- max(sapply(smat, length))
#   if (any(sapply(smat, length) == 1)) stop("Warning: sample with one or zero features")
# 
#   smat2 <- array(NA, dim = c(leng, nrow(mat)))
#   for (i in 1:nrow(mat)) {
#     smat2[leng:(leng - length(smat[i]) + 1), i] = smat[i]
#   }
# 
#   rmat2 <- apply(smat2, 1, function(row) {
#     quantile(row, probs = seq(0, 1, length.out = ncol(smat2)), na.rm = TRUE)
#   })
# 
#   smat2[is.na(smat2)] = 0
#   ref1 <- colMeans(smat2)
# 
#   ncols <- ncol(rmat2)
#   diffr <- apply(rmat2, 1, function(row) {
#     ref1 - row
#   })
#   diffr1 <- matrixStats::colMedians(abs(diffr))
# 
#   x <- which(abs(diff(diffr1)) / diffr1[-1] > rel)[1] / length(diffr1)
#   if (x <= 0.50) {
#     message("Default value being used.")
#     x <- 0.50
#   }
# 
#   return(x)
# }


###############
## setup the MRexperiment object
## phenodat: sample data.frame with rownames being the
## sampleID (crucial), first column also the sampleID here
## OTUdata: feaure data.frame with rownames being the featID
## (crucial). first column also the featID
## cntdat: matrix data.frame with rownames being the featID and
## colnames as sampleID
###############

setMRobject <- function(cntdat, phenodat, featdat) {
  suppressPackageStartupMessages(require("metagenomeSeq"))
  phenodatDF <- as.data.frame(phenodat)
  phenotypeData <- AnnotatedDataFrame(phenodatDF)

  featdatDF <- as.data.frame(featdat)
  OTUdata <- AnnotatedDataFrame(featdatDF)

  cntdatDF <- as.data.frame(cntdat)

  obj <- newMRexperiment(cntdatDF, phenoData = phenotypeData, featureData = OTUdata)
  return(obj)
}

###############
  ### Filter OTU/Taxa presence with a chosen read count
  ### 'present' for the number of samples the feature is at least present in
  ### 'fdepth' for feature count cutoff for presence, a taxa/OTU has to have
  ### at least this number of reads to be deemed present within a sample.
  ### 'depth' for the total number reads a sample has to at least have
###############
filterMRobject <- function(obj, present = 1, fdepth = 1, depth = 1, norm = FALSE) {
  mat <- returnAppropriateObj(obj, norm = norm, log = FALSE) > (fdepth - 1)
  cols <- which(colSums(MRcounts(obj, norm = norm)) >= depth)
  rows <- which(rowSums(mat[, cols]) >= present)

  # Apply filter
  obj <- obj[rows, cols]
  return(obj)
}


###############
# Normalize the data with percentile param
# When percentile is NULL, normalization factor will be calculated
###############
normMRobject <- function(obj, percentile = NULL) {
  # Calculating normalization factor
  if (is.null(percentile)) {
    percentile <- cumNormStat(obj)

  }
  # Apply normalization
  obj <- cumNorm(obj, p = signif(percentile, 4))
  return(obj)
}

###############
# plot histograms to get a sense of the counts and presence
###############
plotHistMeta <- function(x, xlab="log2(Sum of counts)", main="Histogram", breaks=50) {
  hist(x, xlab = xlab, main = main, breaks = breaks)
}

##################
# Boxplot of distributions: Before and after normalization in log2 form
##################
boxplotMeta <- function(obj, keyAnnot, cols = NULL) {
  #color setup
  if (is.null(cols)) {
    suppressPackageStartupMessages(require("RColorBrewer"))
    cols <- c(brewer.pal(8, "Accent"), rev(brewer.pal(8, "Dark2")[-8]), brewer.pal(8, "Paired"))
  }

  cl <- factor(pData(obj)[, keyAnnot])
  clcol <- cols[as.integer(cl)]

  #plot
  par(mfrow = c(2, 1))
  boxplot(log2(1 + MRcounts(obj, norm = F, log = F)), col = clcol, outcol = clcol, ylab = "log2(1+Abundance)")
  boxplot(log2(1 + MRcounts(obj, norm = T, log = F)), col = clcol, outcol = clcol, ylab = "log2(1+Abundance)")
}



##################
# PCoA - Bray-Curtis
##################
fitPCoA <- function(obj, method = "bray", norm = T) {
  suppressPackageStartupMessages(library("vegan"))
  suppressPackageStartupMessages(library("ape"))

  #### distance computation and dimension reduction
  d <- vegdist(t(MRcounts(obj, norm = norm, log = F)), method = method)
  pcodecomp <- pcoa(d)

  # if any eigenvalue is negative, leverage Cailliez correction
  if (sum(pcodecomp$values$Relative_eig < 0) > 0) {
    pcodecomp <- pcoa(d, correction = "cailliez")
  }
  return(pcodecomp)
}

##################
# Plot PCoA - Bray-Curtis
##################
plotPCoA <- function(obj, pcodecomp, keyAnnot, keyAnnot2=NULL, dimn=2, fileNameAdd="", cols=NULL){
  suppressPackageStartupMessages(require(ape))
  
  #color setup
  if(is.null(cols)){
    suppressPackageStartupMessages(require("RColorBrewer"))
    cols = c(brewer.pal(8, "Accent"),rev(brewer.pal(8, "Dark2")[-8]), brewer.pal(8,"Paired"))
  }
  cl=cl2=factor(pData(obj)[,keyAnnot])
  clcol=cols[as.integer(cl)]
  
  # if a secondary annotation were specified, pch is used
  if(!is.null(keyAnnot2)){
    cl2 <- factor(pData(obj)[,keyAnnot2])
  }
  pch2use=c(1: length(levels(cl2)))
  pchInput=pch2use[cl2]
  
  # Compute the percentage of explained variance
  PCOAaxes <- pcodecomp$vectors[,c(1:dimn)]
  eignPERC<- pcodecomp$values$Rel_corr_eig[c(1:dimn)]
  
  # plot PCoA
  pairs(PCOAaxes, main=paste("PCoA", fileNameAdd), col=clcol, pch=pchInput, 
        cex=1.1, cex.labels = 2, cex.axis=1.5, upper.panel=NULL,
        labels=paste("Dim",1:dimn,"\n",round(eignPERC,3)*100,"%"))  
  if(is.null(keyAnnot2)){
    legend("topright", legend = levels(cl), col=cols, pch=pch2use, ncol=3, cex=1)#, inset = c(0.1, 0.1)) 
  }else{
    legend("top", legend = levels(cl), col=cols, pch = 1, ncol=3, cex=1, inset = c(0.1, 0.1)) 
    legend("topright", legend = levels(cl2), pch=pch2use, cex=1, inset = c(0.1, -0.1)) 
  }
  
}

source(file.path(R_SCRIPTS_PATH, "plotting_utils.R"))


plot_scaler <- function(
    x1,
    x2 = NULL,
    y1 = NULL,
    y2 = NULL,
    path = NULL,
    input_columns1 = NULL,
    input_columns2 = NULL,
    label_name1 = NULL,
    label_name2 = NULL,
    ylab = NULL,
    xlab = NULL,
    ylim = NULL,
    before_title = NULL,
    after_title = NULL,
    legend_position = NULL,
    add_box = TRUE,
    horizontal_plot = FALSE,
    order = FALSE,
    col_set = "Set1",
    cols = NULL,
    log_num = NULL,
    show_outliers = TRUE) {

  suppressPackageStartupMessages(require(patchwork))
  
  if (is.null(y2)) {
    y2 <- y1
  }
  p1 <- generate_violin(
    x1, y1,
    column = input_columns1, label_name = label_name1, ylim = ylim,
    xlab = xlab, ylab = ylab, title = before_title, legend_position = legend_position,
    add_box = add_box, horizontal_plot = horizontal_plot, order = order,
    col_set = col_set, cols = cols, log_num = log_num, show_outliers = show_outliers
  )
  if (!is.null(x2)) {
    p2 <- generate_violin(
      x2, y2,
      column = input_columns2, label_name = label_name2, ylim = ylim,
      xlab = xlab, ylab = ylab, title = after_title, legend_position = legend_position,
      add_box = add_box, horizontal_plot = horizontal_plot, order = order,
      col_set = col_set, cols = cols, log_num = log_num, show_outliers = show_outliers
    )
    the_plot <- p1 / p2
  } else {
    the_plot <- p1
  }
  if (!is.null(path)) {
    save_plots(path, plot = the_plot, width = 6, height = 6, dpi = 600)
  }
  return(path)
}

##

source(file.path(R_SCRIPTS_PATH, "plotting_utils.R"))


plot_feature_selector <- function(
    list_of_sums, path,
    xlabs,
    mains,
    legend_position = "top",
    legend_title = "Feature Selection",
    before_name = "Before",
    after_name = "After",
    xlog = NULL,
    ylog = NULL,
    ...) {

  suppressPackageStartupMessages(require(ggplot2))
  suppressPackageStartupMessages(require(RColorBrewer))
  suppressPackageStartupMessages(require(circlize))
  suppressPackageStartupMessages(require(patchwork))

  if (!is.list(list_of_sums) && !is.vector(list_of_sums)) {
    list_of_sums <- list(list_of_sums)
  }

  if (!is.list(xlabs) && !is.vector(xlabs)) {
    xlabs <- list(xlabs)
  }

  if (!is.list(mains) && !is.vector(mains)) {
    mains <- list(mains)
  }

  if (length(xlabs) != length(list_of_sums) && length(xlabs) == 1) {
    xlabs <- rep(xlabs, length(list_of_sums))
  }

  if (length(mains) != length(list_of_sums) && length(mains) == 1) {
    mains <- rep(mains, length(list_of_sums))
  }
  plots <- NULL
  for (i in 1:length(list_of_sums)) {
    x1 <- as.vector(list_of_sums[[i]][[1]])
    x2 <- as.vector(list_of_sums[[i]][[2]])
    if (is.null(plots)) {
      plots <- generate_comparison_histogram(x1, x2, xlab = xlabs[[i]], title = mains[[i]], xlog = xlog, ylog = ylog)
    } else {
      plots <- plots + generate_comparison_histogram(x1, x2, xlab = xlabs[[i]], title = mains[[i]], xlog = xlog, ylog = ylog)
    }
  }

  grid <- plots + plot_layout(guides = "collect", ncol=ncol) &
    theme(text = element_text(size = 8), legend.position = legend_position)
  save_plots(path, plot = grid, width = 6, height = 6.5, dpi = 600)
}

source()

plot_rfe_feature_selector_for_genomics <- function(
    x1, x2,
    legend_title = "Feature Selection by Recursive Feature Elimination",
    ...) {
    args <- list(...)
    args$x1 <- x1
    args$x2 <- x2
    args$legend_title <- if ("legend_title" %in% names(args)) args$legend_title else legend_title
    do.call(plot_feature_selector_for_genomics, args)
}


plot_rfe_feature_selector_snp <- function(
    x1, x2,
    feature_main = "By GenomicVariantss",
    ...) {
    args <- list(...)
    args$x1 <- x1
    args$x2 <- x2
    args$feature_main <- if ("feature_main" %in% names(args)) args$feature_main else feature_main
    do.call(plot_rfe_feature_selector_for_genomics, args)
}

source(paste0(R_SCRIPTS_PATH, "/utils.R"))

install_dependencies <- function() {
  dependencies <- c(
    "ggplot2", "arrow", "circlize", "RColorBrewer", "scales",
    "forcats", "patchwork", "reshape2", "ComplexHeatmap",
    "edgeR", "dplyr", "tools"
  )
  ensure_packages(dependencies)
}

# Full path: src/biofit/preprocessing/scaling/tmm/tmm.R
# adapted from ruppinlab/sklearn-extensions and edgeR::calcNormFactors source code

source(file.path(R_SCRIPTS_PATH, "utils.R"))

edger_tmm_ref_column <- function(counts, lib_size=colSums(counts), p=0.75) {
  y <- t(t(counts) / lib_size)
  f <- apply(y, 2, function(x) quantile(x, p=p))
  ref_column <- which.min(abs(f - mean(f)))
}

edger_tmm_fit <- function(X) {
  suppressPackageStartupMessages(require(edgeR))
  suppressPackageStartupMessages(require(arrow))
  X <- as.matrix(as.data.frame(X))
  counts <- t(X)
  ref_sample <- counts[, edger_tmm_ref_column(counts)]
  return(ref_sample)
}

edger_tmm_cpm_transform <- function(X, ref_samples, log=TRUE, prior_count=2) {
  suppressPackageStartupMessages(require(edgeR))
  suppressPackageStartupMessages(require(arrow))
  X <- as.matrix(convert_to_dataframe(X))
  counts <- t(X)
  ref_sample_mask <- apply(counts, 2, function(c) all(c == ref_samples))
  if (any(ref_sample_mask)) {
    dge <- edgeR::DGEList(counts=counts)
    dge <- edgeR::calcNormFactors(
      dge, method="TMM", refColumn=min(which(ref_sample_mask))
    )
    cpms <- edgeR::cpm(dge, log=log, prior.count=prior_count)
  } else {
    counts <- cbind(counts, ref_samples)
    colnames(counts) <- NULL
    dge <- edgeR::DGEList(counts=counts)
    dge <- edgeR::calcNormFactors(dge, method="TMM", refColumn=ncol(dge))
    cpms <- edgeR::cpm(dge, log=log, prior.count=prior_count)
    cpms <- cpms[, -ncol(cpms)]
  }
  return(arrow::as_arrow_table(as.data.frame(t(cpms))))
}

edger_tmm_tpm_transform <- function(
    X, feature_meta, ref_samples, log=TRUE, prior_count=2, meta_col="Length"
) {
  if (is.null(feature_meta)) stop("feature_meta cannot be NULL")
  suppressPackageStartupMessages(require(edgeR))
  suppressPackageStartupMessages(require(arrow))
  X <- as.matrix(convert_to_dataframe(X))
  counts <- t(X)
  ref_sample_mask <- apply(counts, 2, function(c) all(c == ref_samples))
  if (any(ref_sample_mask)) {
    dge <- edgeR::DGEList(counts=counts, genes=feature_meta)
    dge <- edgeR::calcNormFactors(
      dge, method="TMM", refColumn=min(which(ref_sample_mask))
    )
  } else {
    counts <- cbind(counts, ref_samples)
    colnames(counts) <- NULL
    dge <- edgeR::DGEList(counts=counts, genes=feature_meta)
    dge <- edgeR::calcNormFactors(dge, method="TMM", refColumn=ncol(dge))
  }
  if (log) {
    # XXX: edgeR doesn't have built-in support for logTPM w/ prior.count
    #      so do API internal logic manually
    # TODO: use effectiveLibSizes() in newer edgeR versions
    lib_size <- dge$samples$lib.size * dge$samples$norm.factors
    scaled_prior_count <- args$prior_count * lib_size / mean(lib_size)
    adj_lib_size <- lib_size + 2 * scaled_prior_count
    fpkms <- t(
      (t(dge$counts) + scaled_prior_count) / adj_lib_size
    ) * 1e6 / dge$genes[[meta_col]] * 1e3
    tpms <- log2(t(t(fpkms) / colSums(fpkms)) * 1e6)
  } else {
    fpkms <- edgeR::rpkm(
      dge, gene.length=meta_col, log=log, prior.count=prior_count
    )
    tpms <- t(t(fpkms) / colSums(fpkms)) * 1e6
  }
  if (!any(ref_sample_mask)) tpms <- tpms[, -ncol(tpms)]
  return(arrow::as_arrow_table(t(tpms)))
}

edger_cpm_transform <- function(X, log=TRUE, prior_count=2) {
  suppressPackageStartupMessages(require(edgeR))
  suppressPackageStartupMessages(require(arrow))
  return(arrow::as_arrow_table(t(edgeR::cpm(t(X), log=log, prior.count=prior_count))))
}

source(file.path(R_SCRIPTS_PATH, "plotting_utils.R"))
source(file.path(R_SCRIPTS_PATH, "utils.R"))

#'
#' Feature importance plot with feature data in the samples.
#' @param X Arrow data table that is logged or in non-logged form depending on the omics data
#' @param y Arrow labels
#' @param sample_metadata Arrow sample metadata
#' @param feature_importances Arrow feature importance table: first column is the feature ID, "feature", second column (and on wards) is/are the importance per final model seed(s)
#' @param path the path for the pdf file to save
#' @param X, y, sample_metadata, feature_importances arrow objects from the biofit framework
#' @param plot_top the number of top features to plot. Default is 15.
#' @param feature_meta_name can be NULL, prints the feature ID; or character such as "species", prints this column, or vector of more than 1 characters c("genus", "species"), then prints the collapsed text with a space in between. Default is NULL.
#' @param plot_title name of the data type, eg "Presence", or "log2 Abundance". Default is NULL.
#' @param column_title eg. "Sample" or "Isolate". Default is NULL.
#' @param row_title eg. "OTU" or "SNP". Default is NULL.
#' @examples
#' \dontrun{
#' # usage for OTU data:
#' plot_feature_importance(X, y, sample_metadata, feature_importances, plot_top = 30, feature_meta_name = c("feature", "genus", "species"), plot_title = "log2\nAbundance", column_title = "Sample", row_title = "OTU")
#' # usage for metagenomics data:
#' plot_feature_importance(X, y, sample_metadata, feature_importances, plot_top = 30, feature_meta_name = c("genus", "species"), plot_title = "log2\nAbundance", column_title = "Sample", row_title = "Taxonomy")
#' # usage for transcriptomics/proteomics (non-MALDI) data: eg
#' plot_feature_importance(X, y, sample_metadata, feature_importances, plot_top = 30, feature_meta_name = c("gene"), plot_title = "log2\nExpression", column_title = "Sample", row_title = "Gene")
#' # usage for genomics data:
#' plot_feature_importance(X, y, sample_metadata, feature_importances, plot_top = 30, feature_meta_name = NULL, plot_title = "Presence", column_title = "Isolate", row_title = "SNP")
#' # usage for MALDI-TOF data:
#' plot_feature_importance(X, y, sample_metadata, feature_importances, plot_top = 30, feature_meta_name = "DaRange", plot_title = "log10\nAbundance", column_title = "Isolate", row_title = "Da range")
#' }
#'
plot_feature_importance <- function(
    X,
    feature_importances,
    path,
    y = NULL,
    sample_metadata = NULL,
    feature_metadata = NULL,
    input_columns = NULL,
    target_columns = NULL,
    sample_metadata_columns = NULL,
    feature_column = NULL,
    feature_meta_name = NULL,
    plot_top = 15,
    cols = NULL,
    col_heat = NULL,
    show_column_names = FALSE,
    plot_title = "Relative Abundance",
    column_title = "Samples",
    row_title = "Taxonomic Relative Abundance") {
  width <- 13
  height <- 7

  X <- convert_to_dataframe(X)
  input_columns <- get_default_columns(X, input_columns, NULL)
  X <- validate_data(X, input_columns)

  if (!is.null(y)) {
    y <- convert_to_dataframe(y)
    target_columns <- get_default_columns(y, target_columns)
    y <- validate_data(y, target_columns)
  }

  if (!is.null(sample_metadata)) {
    sample_metadata <- convert_to_dataframe(sample_metadata)
    sample_metadata_columns <- get_default_columns(
      sample_metadata, sample_metadata_columns, NULL
    )
    sample_metadata <- validate_data(sample_metadata, sample_metadata_columns)
  }

  if (is.null(sample_column)) {
    sample_column <- sample_metadata_columns[1]
  }


  if (!is.null(feature_metadata)) {
    feature_metadata <- convert_to_dataframe(feature_metadata)
    if (is.list(feature_meta_name)) {
      feature_meta_name <- as.vector(unlist(feature_meta_name))
    }
    feature_meta_name <- get_default_columns(
      feature_metadata, feature_meta_name
    )
    feature_metadata <- validate_data(feature_metadata, feature_meta_name)
    rownames(feature_metadata) <- feature_metadata[, feature_column]
  }

  suppressPackageStartupMessages(require(ComplexHeatmap))
  suppressPackageStartupMessages(require(grid))
  suppressPackageStartupMessages(require(circlize))
  suppressPackageStartupMessages(require(RColorBrewer))

  ## get label and feature information
  ## convert arrow data format to data frame
  if (!is.null(feature_metadata)) {
    feature_metadata <- convert_to_dataframe(feature_metadata)
  }


  feature_importances <- convert_to_dataframe(feature_importances)
  top_feat_id <- feature_importances[, 1]
  rownames(feature_importances) <- feature_importances[, feature_column]
  # drop feature column
  not_feature_column <- setdiff(colnames(feature_importances), feature_column)
  feature_importances <- feature_importances[, not_feature_column]


  y <- factor(as.vector(convert_to_dataframe(y)[, 1]))

  rownames(X) <- sample_metadata[, sample_column]

  ### make sure plot_top is numeric
  if (!is.numeric(plot_top)) {
    stop("plot_top, the number of top features to plot, must be numeric.")
  }

  ### color selected from plotting_utils.R to be consistent
  if (is.null(cols)) {
    cols <- color_select(length(levels(y)))
    names(cols) <- levels(y)
  }

  ### if col_heat not specified
  if (is.null(col_heat)) {
    col_heat <- brewer.pal(9, "YlOrRd")
  }

  ## Define the feature/text annotation with row names
  ## plot feature ID if not specified
  if (is.null(feature_meta_name) || is.null(feature_metadata)) {
    feat_on_plot <- top_feat_id
  } else {
    ## for more than one feature meta columns to display
    if (length(feature_meta_name) > 1) {
      if (!(feature_column %in% feature_meta_name)) {
        feature_meta_name <- c(feature_column, feature_meta_name)
      }
      feat_on_plot <- apply(
        feature_metadata[top_feat_id, feature_meta_name],
        1,
        paste,
        collapse = "\n"
      )
    } else { ## for one feature meta columns to display
      feat_on_plot <- feature_metadata[top_feat_id, feature_meta_name]
    }
  }

  ##################
  ## generate feature importance plot
  ##################
  ### the feature boxplot/barplot
  # remove UNINTEGRATED from top_feat_id
  hdat2plot <- t(data.matrix(X[, top_feat_id]))

  print(hdat2plot)
  print(col_heat)
  if (ncol(feature_importances) == 1) {
    ha2 <- ComplexHeatmap::rowAnnotation(
      ` ` = row_anno_points(
        feature_importances[top_feat_id, ],
        axis = TRUE, outline = FALSE
      ),
      width = unit(3, "cm")
    )
  } else {
    ha2 <- ComplexHeatmap::rowAnnotation(
      ` ` = row_anno_boxplot(
        data.matrix(feature_importances[top_feat_id, ]),
        axis = TRUE,
        outline = FALSE
      ),
      width = unit(3, "cm")
    )
  }

  ### the sample annotation in the column
  ### (Added a name hack here to be Importance
  ### as the label is above feature importance box/dot plot)
  ha1 <- ComplexHeatmap::HeatmapAnnotation(
    df = data.frame(Importance = y),
    show_legend = TRUE,
    col = list(Importance = cols),
    annotation_legend_param = list(
      title = target_columns,
      legend_direction = "vertical"
    )
  )

  ### add feature names to rows
  text_annotation <- rowAnnotation(
    text = anno_text(
      feat_on_plot,
      just = "left",
      gp = gpar(fontsize = 10)
    )
  )

  ### plot histogram and add the 3 components from above
  h2plot <- ComplexHeatmap::Heatmap(hdat2plot,
    cluster_rows = FALSE, col = col_heat, top_annotation = ha1,
    heatmap_legend_param = list(
      title = plot_title, color_bar = "continuous",
      legend_direction = "vertical"
    ),
    show_column_names = show_column_names,
    row_title = row_title, # Title for the rows
    column_title = column_title, # Title for the columns
    row_title_side = "left", # Position of the row title
    column_title_side = "top"
  ) +
    ha2 + text_annotation # , top_annotation_height = unit(1, "cm")
  start_device(path, width = width, height = height, units = "in", res = 300)
  draw(h2plot)
  dev.off()
}

BIOCONDUCTOR <- c(
  "limma", "metagenomeSeq", "phyloseq",
  "DESeq2", "biomaRt", "GenomicRanges",
  "Biostrings", "BSgenome", "GenomicFeatures",
  "GenomicAlignments", "VariantAnnotation",
  "S4Vectors", "IRanges", "AnnotationDbi",
  "ComplexHeatmap"
)

save_plots <- function(
    filename, plot = last_plot(), device = NULL, path = NULL,
    scale = 1, width = NA, height = NA, units = c(
      "in", "cm",
      "mm", "px"
    ), dpi = 300, limitsize = TRUE, bg = NULL,
    create.dir = TRUE, ...) {
  suppressPackageStartupMessages(c(
    require(ggplot2)
  ))


  ext <- NULL
  if (!is.null(filename)) {
    ext <- tolower(tools::file_ext(filename))
  } else if (!is.null(path)) {
    ext <- tolower(tools::file_ext(path))
  }

  # always save a png if ext is not png
  if (ext != "png") {
    fn <- paste0(tools::file_path_sans_ext(filename), ".png")

    ggplot2::ggsave(
      fn,
      plot = plot, device = "png",
      path = path, scale = scale, width = width,
      height = height, units = units, dpi = dpi,
      limitsize = limitsize, bg = bg, create.dir = create.dir, ...
    )
  }
  ggplot2::ggsave(
    filename,
    plot = plot, device = device,
    path = path, scale = scale, width = width,
    height = height, units = units, dpi = dpi,
    limitsize = limitsize, bg = bg, create.dir = create.dir, ...
  )
}

get_info_from_arrow_table <- function(arrow_table) {
  # Get the schema
  info <- arrow_table$schema$metadata$huggingface
  if (is.null(info)) {
    return(NULL)
  }
  jsonlite::fromJSON(info)$info$features
}

#' @title arrow_to_factor
#' @description Convert label encodings to factors.
#' Uses the arrow metadata to get the label information.
#' @param y The arrow table
#' @return if y is not an arrow table or y is not a class label,
#' it returns y as is.
encodings_to_factor <- function(y) {
  # verify that y is an arrow table
  if (!inherits(y, "Table")) {
    return(y)
  }
  label_info <- get_info_from_arrow_table(y)$features$labels
  if (is_class(label_info)) {
    return(y)
  }
  # Add a label for missing values
  label_names <- c("", label_info$names)
  y <- as.data.frame(y)[, 1]
  # labels ranges from -1 to n-1,
  # where n is the number of classes and a -1 is a missing value
  factor(y + 2,
    levels = seq_along(label_names),
    labels = label_names
  )
}

is_class <- function(label_info) {
  if (label_info$`_type` != "ClassLabel") {
    return(TRUE)
  }
  FALSE
}

#' detect using class what each variable type is
#' @param data data frame containing the data
#' @param col name of the column that is being checked
detect_var_type <- function(data, col) {
  cat_types <- c("character", "logical")
  num_types <- c("numeric", "integer", "double")

  if (class(data[[col]]) %in% cat_types) {
    col_type <- "categorical"

    if (is_other_var(data, col)) {
      col_type <- "other"
    }
  } else if (class(data[[col]]) %in% num_types) {
    col_type <- "numerical"

    if (!is_other_var(data, col)) {
      col_type <- "categorical"
    }
    if (length(unique(data[[col]])) <= 1) {
      col_type <- "other"
    }
  }
  return(col_type)
}

#' For detecting our classification of other variable
#' @param data data frame containing the data
#' @param col name of variable being checked
#' @param threshold max number of levels
is_other_var <- function(data, col, threshold = 30) {
  other_var <- FALSE

  num_levels <- length(unique(data[[col]]))
  # if there are more than 30 levels we consider this an other variable
  if (num_levels > threshold || num_levels <= 1) {
    other_var <- TRUE
  }

  return(other_var)
}

get_feature_metadata <- function(data) {
  # Create a metadata table for the features
  feature_metadata <- get_info_from_arrow_table(data)

  extract_metadata <- function(item) {
    return(item$metadata)
  }
  # Extract and combine the metadata from each item into a data frame
  metadata_list <- lapply(feature_metadata, extract_metadata)
  metadata_df <- dplyr::bind_rows(metadata_list)
  # add the feature names to the metadata
  metadata_df$feature <- colnames(data)
  return(metadata_df)
}

start_device <- function(path, ...) {
  # Start the device
  if (is.null(path)) {
    path <- tempfile()
  }
  ext <- tolower(tools::file_ext(path))
  if (ext == "pdf") {
    args <- list(...)
    pdf(path, width = args$width, height = args$height)
  } else if (ext == "png") {
    png(path, ...)
  } else if (ext == "jpeg" || ext == "jpg") {
    jpeg(path, ...)
  } else if (ext == "bmp") {
    bmp(path, ...)
  } else if (ext == "tiff") {
    tiff(path, ...)
  } else {
    stop("Unsupported file format")
  }
}


is_dataframe <- function(data) {
  is(data, "Table") ||
    is(data, "RecordBatch") ||
    is.data.frame(data)
}


is_vector <- function(data) {
  is(data, "Array") ||
    is(data, "ChunkedArray") ||
    is.vector(data)
}


convert_to_dataframe <- function(value) {
  if (is_dataframe(value)) {
    as.data.frame(value)
  } else if (is_vector(value)) {
    `colnames<-`(as.data.frame(value), NULL)
  } else {
    stop(paste0("Unsupported object type: ", class(data)))
  }
}

get_default_columns <- function(data, default = NULL, max_cols = 1) {
  if (
    is_dataframe(data) &&
      (
        is.null(max_cols) ||
          ncol(data) == max_cols
      ) &&
      !is.null(colnames(data))
  ) {
    colnames(data)
  } else {
    default
  }
}

validate_data <- function(data, names, required = FALSE, replace = TRUE) {
  if (is_dataframe(data)) {
    if (!is.null(names)) {
      if (!all(names %in% colnames(data)) && !replace) {
        stop(paste0("Column name ", names, " is not in the data"))
      }
    } else if (required) {
      stop("A column name was not provided")
    }
    if (ncol(data) == length(names) && replace) {
      colnames(data) <- names
    }
    data
  } else {
    stop("Data must be a data frame")
  }
}


concatenate_datasets <- function(data1, data2, how = "horizontal") {
  if (is_dataframe(data1) || is_dataframe(data2)) {
    if (how == "vertical") {
      rbind(data1, data2)
    } else {
      cbind(data1, data2)
    }
  } else if (is_vector(data1) && is_vector(data2)) {
    if (how == "vertical") {
      c(data1, data2)
    } else {
      cbind(data1, data2)
    }
  } else {
    stop("Data types must match")
  }
}
